#include <stdio.h>
#include <string.h>
#include <ctype.h>

using namespace std;

struct Letter
{
    char code;
    int frequency;
};

const int M=26;
Letter b[M];

void bubbleSort(Letter *array,int length)//Bubble sort function
{
    int i,j;
    for(i=0;i<length;i++)
    {
        for(j=0;j<i;j++)
        {
            if(array[i].frequency>array[j].frequency)
            {
                Letter temp=array[i]; //swap
                array[i]=array[j];
                array[j]=temp;
            }
        }
    }
}

int main()
{
    FILE *input = fopen("..\\..\\History.txt","rt"); // Read Text
    if(input==NULL)
    {
        printf("Faili ei saa avada!\n");
        return 0;
    }
    for(int i=0;i<M;i++)
    {
        b[i].code = 'A'+i;
        b[i].frequency = 0;
    }
    int ridu=0, marke=0, tahti=0, numbreid=0, sonu=0;
    while(!feof(input))
    {
        char line[500];
        fgets(line,500,input);
        printf("%s",line);
        ridu++;
        int n = strlen(line);
        marke += n;
        for(int i=0;i<n;i++)
            if( isalpha(line[i]) )
            {
                tahti++;
                char c = toupper(line[i]);
                b[c-'A'].frequency++;
            }
            else if( isdigit(line[i]))
                numbreid++;
        char *p = line;
        while(p=strtok(p," .,:;-/()\"\n"))
        {
            printf("%s\n",p);
            sonu++;
            p=NULL;
        }
    }
    fclose(input);
    printf("\nKokku %d rida, %d mrki, %d thte, %d numbrit, %d sna\n",
             ridu,marke+ridu,tahti,numbreid,sonu);

    bubbleSort(b,M);
    for(int i=0;i<M;i++)
    {
        printf("%c   %d\n",b[i].code,b[i].frequency);
    }
    return 0;
}
